package algorithm

import "testing"

func TestLinearSearch(t *testing.T) {
	t.Parallel()

	numbers := []int{3, 4, 5, 3, 2, 1}
	equalFunc := func(a, b int) bool {
		return a == b
	}

	index := LinearSearch(numbers, 5, equalFunc)
	if index != 2 {
		t.Errorf("TestLinearSearch failed, expected %v, got %v", 2, index)
	}
}

func TestBinarySearch(t *testing.T) {
	t.Parallel()

	sortedNumbers := []int{1, 2, 3, 4, 5, 6, 7, 8}
	comparator := &intComparator{}

	index := BinarySearch(sortedNumbers, 5, 0, len(sortedNumbers)-1, comparator)
	if index != 4 {
		t.Errorf("TestBinarySearch failed, expected %v, got %v", 4, index)
	}
}

func TestBinaryIterativeSearch(t *testing.T) {

	sortedNumbers := []int{1, 2, 3, 4, 5, 6, 7, 8}
	comparator := &intComparator{}

	index := BinaryIterativeSearch(sortedNumbers, 5, 0, len(sortedNumbers)-1, comparator)
	if index != 4 {
		t.Errorf("TestBinaryIterativeSearch failed, expected %v, got %v", 4, index)
	}
}
