package crypto

import (
	"crypto/md5"
	"crypto/sha256"
	"encoding/hex"
	"golang.org/x/crypto/pbkdf2"
)

// Md5 MD5加密
func Md5(str string) string {
	h := md5.New()
	h.Write([]byte(str)) // 需要加密的字符串为
	return hex.EncodeToString(h.Sum(nil))
}
func getMd5HexDigest(s string) string {
	hash := md5.Sum([]byte(s))
	return hex.EncodeToString(hash[:])
}

type DtPbkdf2SaltCredManager struct{}

func NewDtPbkdf2SaltCredManager() *DtPbkdf2SaltCredManager {
	cm := &DtPbkdf2SaltCredManager{}
	return cm
}

func (cm *DtPbkdf2SaltCredManager) GetHashedPassword(password string, userSalt string) string {
	hash := pbkdf2.Key([]byte(password), []byte(userSalt), 10000, 32, sha256.New)
	return hex.EncodeToString(hash)
}

func (cm *DtPbkdf2SaltCredManager) IsPasswordCorrect(plainPwd string, hashedPwd string, userSalt string, organizationSalt string) bool {
	return hashedPwd == cm.GetHashedPassword(plainPwd, userSalt)
}
