package utils

import (
	"context"
	"github.com/cloudwego/kitex/pkg/remote/trans/nphttp2/metadata"
)

func GetHqVersion(ctx context.Context) string {
	if md, ok := metadata.FromIncomingContext(ctx); ok {
		if appVersion, ok := md["hq-version"]; ok && len(appVersion) > 0 {
			return appVersion[0]
		}
	}
	return ""
}

func GetPosVersion(ctx context.Context) string {
	if md, ok := metadata.FromIncomingContext(ctx); ok {
		if appVersion, ok := md["pos-version"]; ok && len(appVersion) > 0 {
			return appVersion[0]
		}
	}
	return ""
}

// GetAuthVersion 前端 sdk 版本号
func GetAuthVersion(ctx context.Context) string {
	if md, ok := metadata.FromIncomingContext(ctx); ok {
		if appVersion, ok := md["auth-version"]; ok && len(appVersion) > 0 {
			return appVersion[0]
		}
	}
	return ""
}

func GetXVersion(ctx context.Context) string {
	if md, ok := metadata.FromIncomingContext(ctx); ok {
		if xVersion, ok := md["x-version "]; ok && len(xVersion) > 0 {
			return xVersion[0]
		}
	}
	return ""
}
func GetDeviceType(ctx context.Context) string {
	if md, ok := metadata.FromIncomingContext(ctx); ok {
		if deviceType, ok := md["deviceType"]; ok && len(deviceType) > 0 {
			return deviceType[0]
		}
	}
	return ""
}
