package utils

import (
	"context"
	"encoding/base64"
	"github.com/cloudwego/kitex/pkg/remote/trans/nphttp2/metadata"
)

const Layout = "2006-01-02 15:04:05"

func GetTraceID(ctx context.Context) string {
	if md, ok := metadata.FromIncomingContext(ctx); ok {
		if traceIDs, ok := md["trace_id"]; ok && len(traceIDs) > 0 {
			return traceIDs[0]
		}
	}
	return ""
}

func GetUserId(ctx context.Context) string {
	if md, ok := metadata.FromIncomingContext(ctx); ok {
		if traceIDs, ok := md["userid"]; ok && len(traceIDs) > 0 {
			return traceIDs[0]
		}
	}
	return ""
}

func GetUserName(ctx context.Context) string {
	if md, ok := metadata.FromIncomingContext(ctx); ok {
		if base64Usernames, ok := md["username"]; ok && len(base64Usernames) > 0 {
			decodedUserNameBytes, err := base64.StdEncoding.DecodeString(base64Usernames[0])
			if err != nil {
				return ""
			}
			return string(decodedUserNameBytes)
		}
	}
	return ""
}
